﻿using System;
using System.Collections.Generic;
using Ozeki.VoIP;

namespace IVR.IVR
{
    class IVRExtension : IExtension
    {
        private List<IVRCallHandler> ivrCallHandlers;

        public IVRExtension(string id)
        {
            ExtensionID = id;
            ivrCallHandlers = new List<IVRCallHandler>();
        }

        public string Type
        {
            get { return "IVR"; }
        }

        public string ExtensionID { get; private set; }

        public void OnCalled(IPBXCall call, IncomingCallParams callParams)
        {
            var ivrCallHandler = new IVRCallHandler(call);
            ivrCallHandlers.Add(ivrCallHandler);
            ivrCallHandler.Completed += HandlerCompleted;
        }

        public void OnMessageReceived(Message message)
        {
        }

        private void HandlerCompleted(object sender, EventArgs e)
        {
            var ivrCallHandler = (IVRCallHandler) sender;
            ivrCallHandlers.Remove(ivrCallHandler);
        }
    }
}
